/*
 * $Id: Action.java,v 1.1.1.1 2002/09/20 16:25:23 kenta Exp $
 *
 * Copyright 2001 Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.bulletmlkxml;

import org.kxml.*;
import org.kxml.parser.*;
import java.io.*;
import java.util.Vector;

/**
 * Action xml data.
 *
 * @version $Revision: 1.1.1.1 $
 */
public class Action implements IActionChoice, IActionElmChoice {
  private String label;
  private IActionChoice[] iac;

  public Action(ParseEvent pe, XmlParser parser) throws IOException {
    Attribute ab = pe.getAttribute("label");
    if ( ab != null ) label = ab.getValue();
    Vector choices = new Vector();
    do {
      parser.skip();
      pe = parser.read();
      if ( pe.getType() == Xml.START_TAG ) {
        String name = pe.getName();
        if ( name.equals("repeat") ) {
          choices.addElement(new Repeat(pe, parser));
        } else if ( name.equals("fire") ) {
          choices.addElement(new Fire(pe, parser));
        } else if ( name.equals("fireRef") ) {
          choices.addElement(new FireRef(pe, parser));
        } else if ( name.equals("changeSpeed") ) {
          choices.addElement(new ChangeSpeed(pe,parser));
        } else if ( name.equals("changeDirection") ) {
          choices.addElement(new ChangeDirection(pe,parser));
        } else if ( name.equals("accel") ) {
          choices.addElement(new Accel(pe,parser));
        } else if ( name.equals("wait") ) {
          choices.addElement(new Wait(pe,parser));
        } else if ( name.equals("vanish") ) {
          choices.addElement(new Vanish());
        } else if ( name.equals("action") ) {
          choices.addElement(new Action(pe, parser));
        } else if ( name.equals("actionRef") ) {
          choices.addElement(new ActionRef(pe, parser));
        }
      }
    } while ( pe.getType() != Xml.END_TAG || !pe.getName().equals("action") );
    iac = new IActionChoice[choices.size()];
    choices.copyInto(iac);
  }

  public final String getLabel() {
    return label;
  }

  public final IActionChoice[] getContent() {
    return iac;
  }
}
