/*
 * $Id: Bullet.java,v 1.1.1.1 2002/09/20 16:25:23 kenta Exp $
 *
 * Copyright 2001 Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.bulletmlkxml;

import org.kxml.*;
import org.kxml.parser.*;
import java.io.*;
import java.util.*;

/**
 * Bullet xml data.
 *
 * @version $Revision: 1.1.1.1 $
 */
public class Bullet implements IBulletElmChoice {
  private String label;
  private Direction direction;
  private Speed speed;
  private IActionElmChoice[] iac;

  public Bullet(ParseEvent pe, XmlParser parser) throws IOException {
    Attribute ab = pe.getAttribute("label");
    if ( ab != null ) label = ab.getValue();
    Vector actions = new Vector();
    do {
	    parser.skip();
      pe = parser.read();
      if ( pe.getType() == Xml.START_TAG ) {
        String name = pe.getName();
        if ( name.equals("direction") ) {
          direction = new Direction(pe, parser);
        } else if ( name.equals("speed") ) {
          speed = new Speed(pe, parser);
        } else if ( name.equals("action") ) {
          actions.addElement(new Action(pe, parser));
        } else if ( name.equals("actionRef") ) {
          actions.addElement(new ActionRef(pe, parser));
        }
      }
    } while ( pe.getType() != Xml.END_TAG || !pe.getName().equals("bullet") );
    iac = new IActionElmChoice[actions.size()];
    actions.copyInto(iac);
  }

  public final String getLabel() {
    return label;
  }

  public final Direction getDirection() {
    return direction;
  }

  public final Speed getSpeed() {
    return speed;
  }


  public final IActionElmChoice[] getActionElm() {
    return iac;
  }
}
