/*
 * $Id: Bulletml.java,v 1.1.1.1 2002/09/20 16:25:23 kenta Exp $
 *
 * Copyright 2001 Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.bulletmlkxml;

import org.kxml.*;
import org.kxml.parser.*;
import java.io.*;

/**
 * Bulletml xml data.
 *
 * @version $Revision: 1.1.1.1 $
 */
public class Bulletml {

  public Bulletml(InputStream is, BulletmlManager manager) throws IOException {
    XmlParser parser = new XmlParser(new InputStreamReader(is));
    ParseEvent pe;

    parser.skip();
    parser.read(Xml.START_TAG, null, "bulletml");

    do {
      pe = parser.read();
      if ( pe.getType() == Xml.START_TAG ) {
        String name = pe.getName();
        if ( name.equals("action") ) {
          manager.bulletmlUtil.addAction(new Action(pe, parser));
        } else if ( name.equals("bullet") ) {
          manager.bulletmlUtil.addBullet(new Bullet(pe, parser));
        } else if ( name.equals("fire") ) {
          manager.bulletmlUtil.addFire(new Fire(pe, parser));
        }
      }
    } while ( pe.getType() != Xml.END_TAG || !pe.getName().equals("bulletml") );

    IActionElmChoice[] iac = manager.bulletmlUtil.getActionStartsWith("top");
    manager.setTopActions(iac);
  }
}
