/*
 * $Id: ChangeSpeed.java,v 1.1.1.1 2002/09/20 16:25:23 kenta Exp $
 *
 * Copyright 2001 Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.bulletmlkxml;

import org.kxml.*;
import org.kxml.parser.*;
import java.io.*;

/**
 * ChangeSpeed xml data.
 *
 * @version $Revision: 1.1.1.1 $
 */
public class ChangeSpeed implements IActionChoice {
  private Speed speed;
  private String term;

  public ChangeSpeed(ParseEvent pe, XmlParser parser) throws IOException {
    do {
      parser.skip();
      pe = parser.read();
      if ( pe.getType() == Xml.START_TAG ) {
        String name = pe.getName();
        if ( name.equals("speed") ) {
          speed = new Speed(pe, parser);
        } else if ( name.equals("term") ) {
          pe = parser.read();
          term = pe.getText();
        }
      }
    } while ( pe.getType() != Xml.END_TAG || !pe.getName().equals("changeSpeed") );
  }

  public final Speed getSpeed() {
    return speed;
  }

  public final String getTerm() {
    return term;
  }
}
