/*
 * $Id: Ref.java,v 1.1.1.1 2002/09/20 16:25:23 kenta Exp $
 *
 * Copyright 2001 Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.bulletmlkxml;

import org.kxml.*;
import org.kxml.parser.*;
import java.io.*;
import java.util.Vector;

/**
 * Action/Bullet/FireRef xml data.
 *
 * @version $Revision: 1.1.1.1 $
 */
public class Ref {
  private String label;
  private Vector prms = new Vector();

  public Ref(ParseEvent pe, XmlParser parser, String tagName) throws IOException {
    Attribute ab = pe.getAttribute("label");
    label = ab.getValue();
    do {
      parser.skip();
      pe = parser.read();
      if ( pe.getType() == Xml.START_TAG ) {
        String name = pe.getName();
        if ( name.equals("param") ) {
          pe = parser.read();
          prms.addElement(pe.getText());
        }
      }
    } while ( pe.getType() != Xml.END_TAG || !pe.getName().equals(tagName) );
  }

  public final String getLabel() {
    return label;
  }

  public final String getParam(int idx) {
    return (String)prms.elementAt(idx);
  }

  public final int getParamCount() {
    return prms.size();
  }
}
