/*
 * $Id: Repeat.java,v 1.1.1.1 2002/09/20 16:25:23 kenta Exp $
 *
 * Copyright 2001 Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.bulletmlkxml;

import org.kxml.*;
import org.kxml.parser.*;
import java.io.*;

/**
 * Repeat xml data.
 *
 * @version $Revision: 1.1.1.1 $
 */
public class Repeat implements IActionChoice {
  private String times;
  private IActionElmChoice action;

  public Repeat(ParseEvent pe, XmlParser parser) throws IOException {
    do {
      parser.skip();
      pe = parser.read();
      if ( pe.getType() == Xml.START_TAG ) {
        String name = pe.getName();
        if ( name.equals("times") ) {
          pe = parser.read();
          times = pe.getText();
        } else if ( name.equals("action") ) {
          action = new Action(pe, parser);
        } else if ( name.equals("actionRef") ) {
          action = new ActionRef(pe, parser);
        }
      }
    } while ( pe.getType() != Xml.END_TAG || !pe.getName().equals("repeat") );
  }

  public final String getTimes() {
    return times;
  }

  public final IActionElmChoice getActionElm() {
    return action;
  }
}
