/*
 * $Id: HormingLaser.java,v 1.2 2002/10/04 14:05:12 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.noiz2;

import jp.gr.java_conf.abagames.bulletmlkxml.*;
import java.util.Random;

/**
 * Handle a homing laser.
 *
 * @version $Revision: 1.2 $
 */
public class HormingLaser {
  public static final int NOT_EXIST = Integer.MIN_VALUE;

  public int x, y;
  private int px, py, mx, my, mpx, mpy, cnt;
  private BulletImpl target;

  private BulletmlPlayer player;
  private Ship ship;

  public HormingLaser(BulletmlPlayer player, Ship ship) {
    this.player = player;
    this.ship = ship;
    x = NOT_EXIST;
  }

  private static Random rnd = new Random();

  public void set(BulletImpl target, int x, int y) {
    this.target = target;
    this.x = px = x; this.y = py = y;
    mx = mpx = (rnd.nextInt()%512);
    my = mpy = 1024;
    cnt = 0;
  }

  public final void move() {
    if ( target.x == NOT_EXIST ) {
      x = NOT_EXIST;
      return;
    }
    int c;
    if ( cnt < 8 ) c = 8-cnt;
    else c = 0;
    mx += (target.x - x)>>(7+c);
    my += (target.y - y)>>(7+c);
    mpx += (target.x - x)>>9;
    mpy += (target.y - y)>>9;
    x += mx; y += my;
    px += mpx; py += mpy;
    if ( y < target.y ) {
      ship.hitLaser(target.x, target.y, mx, my);
      x = NOT_EXIST;
      if ( target.hit() ) {
        ship.destroyEnemy(target.px, target.py, target.type);
      }
      return;
    }
    cnt++;
  }

  public final void draw() {
    player.drawHormingLaser(x, y, px, py, cnt);
  }
}