/*
 * $Id: Spark.java,v 1.2 2002/10/04 14:05:13 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.noiz2;

import jp.gr.java_conf.abagames.bulletmlkxml.*;
import java.util.Random;

/**
 * Handle a spark.
 *
 * @version $Revision: 1.2 $
 */
public class Spark {
  public static final int NOT_EXIST = Integer.MIN_VALUE;

  public int x;
  private int y, mx, my, cnt;
  private BulletmlPlayer player;

  public Spark(BulletmlPlayer player) {
    this.player = player;
    x = NOT_EXIST;
  }

  private static Random rnd = new Random();

  public void set(int x, int y, int mx, int my) {
    this.x = x; this.y = y;
    this.mx = mx; this.my = my;
    cnt = Math.abs(rnd.nextInt())%24+16;
  }

  public final void move() {
    x += mx; y += my;
    mx -= mx>>5; my -= my>>5;
    cnt--;
    if ( cnt < 0 ) x = NOT_EXIST;
  }

  public final void draw() {
    player.drawSpark(x, y);
  }
}
